package cn.iocoder.yudao.module.system.api.dept;

import cn.iocoder.yudao.framework.common.util.collection.CollectionUtils;
import cn.iocoder.yudao.module.system.api.dept.dto.DeptRespDTO;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 部门 API 接口
 *
 * @author 芋道源码
 */
public interface DeptApi {
    /**
     * 创建部门信息
     *
     * @param deptRespDTO 部门对象
     * @return 部门id
     */
    Long saveDept(DeptRespDTO deptRespDTO);

    /**
     * 批量删除部门
     * @author vinjor-M
     * @date 17:17 2024/8/3
     * @param ids 部门ids
    **/
    void deleteDept(Set<Long> ids);

    /**
     * 获得部门信息
     *
     * @param id 部门编号
     * @return 部门信息
     */
    DeptRespDTO getDept(Long id);

    /**
     * 获得部门信息
     *
     * @param parentId 上级部门编号
     * @return 部门信息
     */
    DeptRespDTO getDeptByParentId(Long parentId);
    /**
     * 获得部门信息
     *
     * @param parentId 上级部门编号
     * @param name 上级部门名称
     * @return 部门信息
     */
    DeptRespDTO getDeptByParentIdAndName(Long parentId,String name);

    /**
     * 查询部门名称是xx的部门
     * @author PQZ
     * @date 10:49 2024/8/7
     * @param name 部门名称
     * @return cn.iocoder.yudao.module.system.api.dept.dto.DeptRespDTO
    **/
    DeptRespDTO getDeptByName(String name);

    /**
     * 获得部门信息数组
     *
     * @param ids 部门编号数组
     * @return 部门信息数组
     */
    List<DeptRespDTO> getDeptList(Collection<Long> ids);

    /**
     * 校验部门们是否有效。如下情况，视为无效：
     * 1. 部门编号不存在
     * 2. 部门被禁用
     *
     * @param ids 角色编号数组
     */
    void validateDeptList(Collection<Long> ids);

    /**
     * 获得指定编号的部门 Map
     *
     * @param ids 部门编号数组
     * @return 部门 Map
     */
    default Map<Long, DeptRespDTO> getDeptMap(Collection<Long> ids) {
        List<DeptRespDTO> list = getDeptList(ids);
        return CollectionUtils.convertMap(list, DeptRespDTO::getId);
    }

    /**
     * 获得指定部门的所有子部门
     *
     * @param id 部门编号
     * @return 子部门列表
     */
    List<DeptRespDTO> getChildDeptList(Long id);

}
